;*********************************************************************
; ISR_TimerOverflow
;*********************************************************************
; $Id: isr_timerovf.s,v 1.11 2013/11/21 13:58:25 jsmcortina Exp $

; * Copyright 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013
; * James Murray and Kenneth Culver
; *
; * This file is a part of MS2/Extra.
; *
; * Origin: James Murray / Kenneth Culver
; * Majority: James Murray / Kenneth Culver
; *
; * You should have received a copy of the code LICENSE along with this source,
; * ask on the www.msextra.com forum if you did not.
; *

.sect .text
.globl ISR_TimerOverflow
             nolist               ;turn off listing
             include "ms2extrah.inc"
             list                 ;turn listing back on
;*********************************************************************

ISR_TimerOverflow:
;  acknowledge interrupt and clear flag
   movb	#128, TFLG2

   ldx    swtimer  ; // top word to make 32 bit timer. software:hardware
   inx
   stx    swtimer
   bclr   flagbyte1, #flagbyte1_ovfclose

   rti
